import 'package:endlich/endlich.dart';
import 'package:riverpod/riverpod.dart';

import 'auto_dispose_provider.dart';
import 'base_provider.dart';

class StateMachineProviderFamilyBuilder {
  const StateMachineProviderFamilyBuilder();

  StateMachineProviderFamily<State, Event, Arg> call<State, Event, Arg>(
    FamilyCreate<State, MachineProviderRef<State, Event>, Arg> create, {
    String? name,
  }) {
    return StateMachineProviderFamily<State, Event, Arg>(create, name: name);
  }

  StateMachineProviderFamily<State, Event, Arg> custom<State, Event, Arg>(
    FamilyCreate<Machine<State, Event>, ProviderRefBase, Arg> create, {
    String? name,
  }) {
    return StateMachineProviderFamily<State, Event, Arg>.custom(create,
        name: name);
  }
}

class AutoDisposeStateMachineProviderBuilder {
  const AutoDisposeStateMachineProviderBuilder();

  AutoDisposeStateMachineProvider<State, Event> call<State, Event>(
    Create<State, AutoDisposeMachineProviderRef<State, Event>> create, {
    String? name,
  }) {
    return AutoDisposeStateMachineProvider<State, Event>(create, name: name);
  }

  AutoDisposeStateMachineProvider<State, Event> custom<State, Event>(
    Create<Machine<State, Event>, AutoDisposeProviderRefBase> create, {
    String? name,
  }) {
    return AutoDisposeStateMachineProvider<State, Event>.custom(create,
        name: name);
  }
}

class AutoDisposeStateMachineProviderFamilyBuilder {
  const AutoDisposeStateMachineProviderFamilyBuilder();

  AutoDisposeStateMachineProviderFamily<State, Event, Arg>
      call<State, Event, Arg>(
    FamilyCreate<State, AutoDisposeMachineProviderRef<State, Event>, Arg>
        create, {
    String? name,
  }) {
    return AutoDisposeStateMachineProviderFamily<State, Event, Arg>(create,
        name: name);
  }

  AutoDisposeStateMachineProviderFamily<State, Event, Arg>
      custom<State, Event, Arg>(
    FamilyCreate<Machine<State, Event>, AutoDisposeProviderRefBase, Arg>
        create, {
    String? name,
  }) {
    return AutoDisposeStateMachineProviderFamily<State, Event, Arg>.custom(
        create,
        name: name);
  }
}
